package com.mortals.xhx.module.site.service.impl;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.util.DataUtil;
import com.mortals.xhx.module.matter.model.MatterDatumEntity;
import com.mortals.xhx.module.matter.model.MatterDatumQuery;
import com.mortals.xhx.module.matter.service.MatterDatumService;
import com.mortals.xhx.module.site.model.SiteMatterEntity;
import com.mortals.xhx.module.user.model.UserCollectEntity;
import com.mortals.xhx.module.user.model.UserCollectQuery;
import com.mortals.xhx.module.user.service.UserCollectService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.site.dao.SiteMatterAssistDao;
import com.mortals.xhx.module.site.model.SiteMatterAssistEntity;
import com.mortals.xhx.module.site.service.SiteMatterAssistService;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
* SiteMatterAssistService
* 辅助接件事项 service实现
*
* @author zxfei
* @date 2023-03-17
*/
@Service("siteMatterAssistService")
public class SiteMatterAssistServiceImpl extends AbstractCRUDServiceImpl<SiteMatterAssistDao, SiteMatterAssistEntity, Long> implements SiteMatterAssistService {

    @Autowired
    private MatterDatumService matterDatumService;
    @Autowired
    private UserCollectService userCollectService;

    @Override
    protected void findAfter(SiteMatterAssistEntity params, PageInfo pageInfo, Context context, List<SiteMatterAssistEntity> list) throws AppException {
        List<MatterDatumEntity> matterDatumFileEntities = matterDatumService.getMatterDatumCount();
        Map<Long,Integer> datumCountMap = new HashMap<>();
        for (MatterDatumEntity item:matterDatumFileEntities){
            datumCountMap.put(item.getMatterId(),item.getCount());
        }
        list.stream().peek(item->{
//            List<MatterDatumEntity> matterDatumFileEntities = matterDatumService.find(new MatterDatumQuery().matterId(item.getMatterId()));
//            if(CollectionUtils.isNotEmpty(matterDatumFileEntities)) {
//                item.setDatumCount(matterDatumFileEntities.size());
//            }else {
//                item.setDatumCount(0);
//            }
            if(datumCountMap.containsKey(item.getMatterId())){
                item.setDatumCount(datumCountMap.get(item.getMatterId()));
            }else {
                item.setDatumCount(0);
            }
        }).count();
        if(context!=null&&context.getUser()!=null){
            List<UserCollectEntity> userCollectEntities = userCollectService.find(new UserCollectQuery().userId(context.getUser().getId()).collectType(1));
            Map<Long,Long> matterMap = new HashMap<>();
            if(CollectionUtils.isNotEmpty(userCollectEntities)){
                for(UserCollectEntity userCollectEntity:userCollectEntities){
                    Long matterId = DataUtil.converStr2Long(userCollectEntity.getBusinessId(),0);
                    matterMap.put(matterId,matterId);
                }
            }else {
                matterMap.put(0l,0l);
            }
            list.stream().peek(item->{
                if(matterMap.containsKey(item.getId())){
                    item.setIsCollect(1);
                }
            }).count();
        }
        super.findAfter(params, context, list);
    }

    @Override
    protected void findAfter(SiteMatterAssistEntity params, Context context, List<SiteMatterAssistEntity> list) throws AppException {
        List<MatterDatumEntity> matterDatumFileEntities = matterDatumService.getMatterDatumCount();
        Map<Long,Integer> datumCountMap = new HashMap<>();
        for (MatterDatumEntity item:matterDatumFileEntities){
            datumCountMap.put(item.getMatterId(),item.getCount());
        }
        list.stream().peek(item->{
//            List<MatterDatumEntity> matterDatumFileEntities = matterDatumService.find(new MatterDatumQuery().matterId(item.getMatterId()));
//            if(CollectionUtils.isNotEmpty(matterDatumFileEntities)) {
//                item.setDatumCount(matterDatumFileEntities.size());
//            }else {
//                item.setDatumCount(0);
//            }
            if(datumCountMap.containsKey(item.getMatterId())){
                item.setDatumCount(datumCountMap.get(item.getMatterId()));
            }else {
                item.setDatumCount(0);
            }
        }).count();
        if(context!=null&&context.getUser()!=null){
            List<UserCollectEntity> userCollectEntities = userCollectService.find(new UserCollectQuery().userId(context.getUser().getId()).collectType(1));
            Map<Long,Long> matterMap = new HashMap<>();
            if(CollectionUtils.isNotEmpty(userCollectEntities)){
                for(UserCollectEntity userCollectEntity:userCollectEntities){
                    Long matterId = DataUtil.converStr2Long(userCollectEntity.getBusinessId(),0);
                    matterMap.put(matterId,matterId);
                }
            }else {
                matterMap.put(0l,0l);
            }
            list.stream().peek(item->{
                if(matterMap.containsKey(item.getId())){
                    item.setIsCollect(1);
                }
            }).count();
        }
        super.findAfter(params, context, list);
    }

    @Override
    public void addViewsCount(Long id) {
        Map<String,Object> data = new HashMap<>();
        data.put("viewsCountIncrement",1);
        Map<String,Object> condition = new HashMap<>();
        condition.put("id",id);
        dao.update(data,condition);
    }
}